SystemOrganization addCategory: #'Magma sunit'!

TestResource subclass: #TestResourceMagma
	instanceVariableNames: 'location session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma sunit'!

!TestResourceMagma commentStamp: 'kph 10/10/2006 09:13' prior: 0!
Provide magma as an SUnit TestResource. For information on this practice see:

http://www.metaprog.com/ESUG/TestResources.pdf

Use a magma database in ramdisk (location is hard wired in MagmaLocalRamdiskLocation-#base to /ramdisk)

Although we could we do not create and delete the database from scratch every test run. If it is present we use it and apply #beEmpty.

!

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:27'!
beEmpty

self initializeRoot: nil! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:24'!
initializeRoot: rootObject

self session commit: [
	[ self session root: rootObject ] on: Warning do: [ :e | e resume ].
].

^rootObject! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/5/2006 00:03'!
isAvailable

^session isOpen! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 22:22'!
location

^location! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 03:38'!
session

^session ! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 12/7/2007 22:27'!
setUp
 
	location := MagmaLocalTestingLocation default.
	location isRepository ifFalse: [ MagmaRepositoryController create: location ].

	session := location newSessionAs: 'sunit'.
	self beEmpty.! !

!TestResourceMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 03:22'!
tearDown
	self beEmpty.
	session disconnectAndClose.
	 

	! !

TestResource subclass: #TestResourceMockMagma
	instanceVariableNames: 'root counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma sunit'!

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:01'!
abort

! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:01'!
begin

! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:01'!
commit

! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:01'!
commit: aBlock

	^aBlock value

! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'gk 8/7/2007 16:12'!
counterIncrementAt: key
	^ self counters at: key put: (self counterValueAt: key) + 1! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'gk 8/7/2007 16:12'!
counterValueAt: key
	^ self counters at: key ifAbsentPut:[ 0 ]! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'gk 8/7/2007 16:06'!
counters

	^counters ifNil: [counters _ Dictionary new]! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:01'!
inTransaction
	^false
! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:24'!
initializeRoot: rootObject

^root := rootObject! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/7/2006 03:10'!
location

^self! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/7/2006 03:10'!
newSessionAs: user

^self! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 6/21/2007 00:53'!
noteOldKeysFor: object
	"Do nothing."! !

!TestResourceMockMagma methodsFor: 'accessing' stamp: 'kph 10/6/2006 06:23'!
root
	"Answer the value of root"

	^ root! !

!TestResourceMockMagma methodsFor: 'accessing' stamp: 'kph 10/6/2006 06:23'!
root: anObject
	"Set the value of root"

	root _ anObject! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 06:00'!
session

^self! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'kph 6/21/2007 00:53'!
stubOut: a
	"Do nothing."! !

!TestResourceMockMagma methodsFor: 'as yet unclassified' stamp: 'gk 8/7/2007 16:11'!
submit: aRequest
	"We fake it by just processing it locally using myself as responder."

	| results |
	results := aRequest requests collect: [:req |
	 	req sendTo: self
	].
	^results size = 1 ifTrue: [ results first ] ifFalse: [ results ]
! !

MagmaLocalLocation subclass: #MagmaLocalTestingLocation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma sunit'!

!MagmaLocalTestingLocation class methodsFor: 'as yet unclassified' stamp: 'kph 12/7/2007 22:30'!
default 

	^ self path: 'magma_testing'! !

!MagmaLocalTestingLocation class methodsFor: 'as yet unclassified' stamp: 'kph 12/7/2007 22:30'!
defaultFor: app

	^ self default! !

!MagmaLocalTestingLocation methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 03:24'!
base

^ FileDirectory on: '/ramdisk'! !

TestCase subclass: #TestCaseUsingMagma
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma sunit'!

!TestCaseUsingMagma class methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:26'!
resources

^Array with: (self useMock ifTrue: [ TestResourceMockMagma ] ifFalse: [ TestResourceMagma ])! !

!TestCaseUsingMagma class methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:25'!
useMock

^ false
! !

!TestCaseUsingMagma methodsFor: 'as yet unclassified' stamp: 'kph 10/10/2006 09:14'!
magma

^self class resources first current! !

!TestCaseUsingMagma methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 23:15'!
usingMock

	^ self class useMock
! !
